<?php

include './core.php';

checkAuth("CA");

cabecera (4);

$command = $_POST['command'];
$errorCode = "a0";

switch ($command) {

   default:
      echo "<h1 class='title'>Selecci&oacute;n del fichero con la clave privada</h1>\n";

      echo "<form method='post' action='raPrivKey_import.php' enctype='multipart/form-data' name='request_import_selfile'>

      <div id='tbox'>
        <h3 class='head_a2b1'>Importaci&oacute;n</h3>
        <div id='tbox_data_a1'>
          <div id='trow'>

            <div id='tname'>Fichero XML:</div>
            <div id='tvalue'><input type='file' name='importFile' size='35'></div>
          </div>
          <div id='trow'>
            <div id='tvalue'><input class='button' type='submit' value='Importar' /></div>
          </div>
        </div>
      </div>

      <input type='hidden' name='command' value='import' />

      </form>";
      break;

   case "import":

      $cantCert = 0;
      $importFileName = $_FILES['importFile']['name'];
    
      echo "<h1 class='title'>Importaci&oacute;n de Clave Privada</h1>\n";
      // Parseamos el fichero XML en un array
      $xmlData = parseXML($_FILES['importFile']['tmp_name']);      
      // Comprobamos si ha habido algun error al hacer el parser
      if ( !$xmlData ) 
         $errorCode = "a2b1c1d2e1";
      else {
         // Obtenemos el tipo de XML
         $xmlType = $xmlData[0]['xmlType'];         
         
         if ( $xmlType == '"privado"' ) {
            $copaId = $xmlData[1]['copa_id'];
            $privKey = $xmlData[1]['private_key'];
            $date = $xmlData[1]['date'];

            // Creamos una cadena con un array que contendra la clave privada,
            // el codigo de la RA y la fecha del cambio de la clave. Este array
            // lo meteremos en un fichero junto con las claves privadas de las 
            // demas RAs
            $privKeyArrayString = "\$raPrivKeyArray['$copaId']['$date'] = \"$privKey\";\n";

            // Si no existe el fichero, lo creamos anyadiendole las etiquetas
            // de inicio y fin de fichero php
            if ( !file_exists($fileVar['privado']) ) {
               $fd = fopen ($fileVar['privado'], "w");
	       if ( !$fd )
                  $errorCode = "a2b1c1d2e2";
               else {
                  $r1 = fputs ($fd, "<?php\n");
                  $r2 = fputs ($fd, "?>\n");
                  if ( !$r1 || !$r2 ) 
                     $errorCode = "a2b1c1d2e3";
               }
               $r = fclose ($fd);
               if ( !$r )
                  $errorCode = "a2b1c1d2e4";
            }

            if ( $errorCode == "a0" ) {
               $fd2 = fopen ($fileVar['privado'], "r+");
               if ( !$fd2 )
                  $errorCode = "a2b1c1d2e2";
               else {
                  // Nos posicionamos sobre la ultima linea, la que contiene el final
                  // del fichero php (? >) y la sobreescribimos
                  fseek($fd2, -3, SEEK_END);
                  $r3 = fputs ($fd2, $privKeyArrayString);
                  // Escribimos de nuevo el fin de fichero php
                  $r4 = fputs ($fd2, "?>\n");            
                  if ( !$r3 || !$r4 )
                     $errorCode = "a2b1c1d2e3";
                  else {
                     echo "<p>La importac&oacute;n de las claves se ha realizado con &eacute;xito.</p>";
                     // Escribimos en el fichero de log los cambios de estado realizados
                     $pkiLog['status'] = "importPrivKey";
                     $pkiLog['eee'] = "none";
                     $pkiLog['user'] = "CA-Admin";
                     $pkiLog['error'] = $errorCode;
                     writeLog ($pkiLog);
                  }
               }            
               fclose($fd2);          
            }
         }
      }

   break; 
}

// Si se ha producido algun error, llamamos a la funcion encargada de
// tratarlos
if ( $errorCode != "a0" ) {
   echo "<h2>Error importando las claves</h2>\n";

   $pkiLog['status'] = $status;
   $pkiLog['eee'] = $copa;
   $pkiLog['user'] = "RAadmin";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);
}

pie ();

?>

